#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

static void processus_fils(void);
static void processus_pere(void);
static void handler(int, siginfo_t *, void *);


int main(int argc,char * argv[])
{
	pid_t pid;
	pid = fork();
	if (pid < 0) {
		perror("fork");
		exit(EXIT_FAILURE);
	}

	if (pid == 0) {
		processus_fils();
	} else {
		processus_pere();
	}
	return EXIT_SUCCESS;
}


static void processus_fils(void)
{
	struct timeval heure;
	union sigval value;
	sleep(2); // Pour etre sur que le pere ait installe son handler
	while (1) {
		gettimeofday(& heure, NULL);
		value.sival_int = heure.tv_usec;
		sigqueue(getppid(), SIGRTMIN, value);
		sleep(1);
	}
}


static void processus_pere(void)
{
	struct sigaction action;
	action.sa_flags = SA_SIGINFO;
	action.sa_sigaction = handler;
	sigfillset(& action.sa_mask);
	sigaction(SIGRTMIN, & action, NULL);
	while (1)
		pause();
}

static void handler(int unused, siginfo_t * info, void * unused_ptr)
{
	struct timeval heure;
	gettimeofday(& heure, NULL);
	heure.tv_usec -= info->si_value.sival_int;
	if (heure.tv_usec < 0)
		heure.tv_usec += 1000000;
	fprintf(stdout, "Duree = %ld micro-secondes\n", heure.tv_usec);
}


